﻿var GridApp = GridApp || { currentSortColumnIndex: 0, globalStopper: false, multiInstanceApp: false  };

//adding some utility methods
GridApp.Url = globalRootAppUrl.substr(-1) == '/' ? globalRootAppUrl.substr(0, globalRootAppUrl.length - 1) : globalRootAppUrl;

//init things onload
$(function () {
	InitCheckboxCellClick();
		
	//init sorting
	GridApp.currentSortColumnIndex = (document.location.href.indexOf("sortBy=") > -1) ? getQueryString()["sortBy"] : $.cookie('sortColNum');

	//save the current host into a jitbit.com cookie for the sign-in link on the main site
	var host = location.protocol + "//" + location.host;
	if (GridApp.multiInstanceApp && (GridApp.isTech || !!$.cookie("hdurl")) && $.cookie("hdurl") != host) {
		$.cookie("hdurl", host, { domain: ".jitbit.com", expires: 30, path: "/" });
	}

	//fill the "custom statuses" select IF there's anything to be filled with.
	//take values from "statusId" select that is present on both search and grid
	//if empty - do not show
	var $statusOptions = $('#statusId option').filter(function () { return $(this).val() > 3; }); //filter out standard statuses
	if ($statusOptions.length) {
		$('#liCustomStatusMenuItem').show();
		$('#selCustomStatusId').append($statusOptions.clone());
	}

	//bind row click (except the checkbox column)
	$("#tblTickets").on("click", ".ticketRow td:not(.cbcell)", function (event) { TicketClick(event, $(this).parent().data("ticketid")); });

	//bind bulk actions dialog show
	$("#bulk-actions-popup ul a[data-dialogid]").click(function (e) {
		HideAllBlocks();
		$("#" + $(e.target).data("dialogid")).show();
	});

	//bind removebadge click
	if (GridApp.isTech) {
		$('.live-badge').attr("title", "User is currently in the live chat widget on the website");
		$("#tblTickets .cust-badge, #tblTickets .fortech-badge")
			.attr('title', 'click to remove this badge')
			.click(function (event) {
				var ticketId = $(event.target).closest("[data-ticketid]").data("ticketid");
				RemoveBadge(event, ticketId);
			});
	}
});

function TicketClick(event, ticketId) {
	if (event.target.tagName == "A") return;
	window.location = GridApp.Url + "/Ticket/" + ticketId;
}

function DeleteSeletedTickets() {
	if (!confirm("Are you sure you want to delete the selected tickets?")) return;
	$('#actionName').val('delete');
	$('#gridForm').submit();
	RemoveCheckedFromGrid();
	$("#bulk-actions-popup").fadeOut(100);
}

function UndeleteSeletedTickets() {
	if (!confirm("Are you sure you want to RESTORE the selected tickets?")) return;
	$('#actionName').val('undelete');
	$('#gridForm').submit();
	RemoveCheckedFromGrid();
	$("#bulk-actions-popup").fadeOut(100);
}

function SpamSeletedTickets() {
	if (!confirm("Are you sure you want to mark the selected tickets as spam?")) return;
	$('#actionName').val('spam');
	$('#gridForm').submit();
	RemoveCheckedFromGrid();
	$("#bulk-actions-popup").fadeOut(100);
}
	
function SortByColNum(colNum) {
	var newUrl = document.location.href;

	if (newUrl.indexOf("sortBy=") > -1 || $.cookie('sortColNum') != null) {
		//get currently 'sorted by' column
		var oldSortCol = GridApp.currentSortColumnIndex;

		newUrl = newUrl.replace(/&sortBy=[^&]+/, '');
		newUrl = newUrl.replace(/\?sortBy=[^&]+&?/, '?');

		if (oldSortCol == colNum)
			colNum = -colNum;
	}

	var sep = newUrl.indexOf("?") > -1 ? "&" : "?";
	newUrl += sep + "sortBy=" + colNum;

	document.location = newUrl;
}

function MergeSelected() {
	if (!confirm("Are you sure you want to merge the selected tickets?")) return;

	var $checkedBoxes = $('.cb:checked'); //save checked boxes here cause they're reset after form.submit

	$('#actionName').val('merge');
	$('#gridForm').submit();
	$("#bulk-actions-popup").fadeOut(100);

	//find minimal ticketId from selected (other will be merged into it) so we later remove all the other ticket from grid
	var ids = $checkedBoxes.map(function () { return $(this).data("ticketid"); }).get().sort();
	$('.cb[name=cbDel' + ids[0] + ']').prop('checked', false).closest("tr").removeClass("highlight"); //uncheck the "merged into" ticket
	RemoveCheckedFromGrid(); //removes CHECKED rows
}

function RemoveCheckedFromGrid() {
	$('.cb:checked').closest("tr").fadeRemove().then(function () {
		//now we need to check if the removed ticket was the last one in the grid. 
		//in that case show a blank-state message
		if ($("#tblTickets tbody tr").length > 0) return; //still some tickets left

		//it was the last one. Hide the grid.
		$("#tblTickets").hide();
		$("#noTicketsMessage").fadeIn();
	});
}
function LinkSelected() {
	if (!confirm("Are you sure you want to link the selected tickets?")) return;
	$('#actionName').val('link');
	$('#gridForm').submit();
}
function PrintSeletedTickets() {
	var qs = $('.cb:checked').map(function () { return [["ids", $(this).attr("data-ticketid")]]; }).get();
	RedirectAndSendPost(GridApp.Url + "/Ticket/PrintMultiple", qs);
}
function TakeoverSelected() {
	if (!confirm("Are you sure you want to take over the selected tickets?")) return;
	$('#actionName').val('takeover');
	$('#gridForm').submit();
	$('.cb:checked').closest("tr").find(".techTd").text(GridApp.currentUsername);
	$("#bulk-actions-popup").fadeOut(100);
}
function LoadTechs() {
	var $divAssignTo = $("#divAssignTo");
	if (!$divAssignTo.is(':visible') && $divAssignTo.has('option').length == 0) {
		//fill techs with ajax
		$.ajax({
			url: GridApp.Url + '/Tickets/GetTechUsers',
			type: "POST",
			success: function (data) {
				var $selTechId = $('#selTechId');
				$selTechId.empty();
				// option to unassign first
				$selTechId.append("<optgroup><option value='0'>Unassign</option></optgroup><optgroup label='-------'>");
				$.each(data, function (i, item) {
					$selTechId.append("<option value='" + item.UserID + "'>" + item.FullNameAndLogin + (item.OutOfOffice ? " 🏝️" : "") + "</option>");
				});
				$selTechId.append("</optgroup>");
			}
		});
	}
}
function LoadCategories() {
	var $divCategory = $("#divCategory");
	if (!$divCategory.is(':visible') && $divCategory.has('option').length == 0) {
		//fill cats with ajax
		$.ajax({
			url: GridApp.Url + '/Ticket/GetCategoriesHtmlSelect',
			type: "POST",
			success: function (data) {
				var $selCategory = $('#selCategory');
				$selCategory.replaceWith(data);
			}
		});
	}
}

function HideAllBlocks() {
	$("#bulk-actions-popup > div").hide();
}
function OnChangeTag(mode) {
	$('#actionName').val('tag' + mode);
	$('#divTags').hide();
	$("#bulk-actions-popup").fadeOut(100);
}
function OnChangeDue() {
	$('#actionName').val('duedate');
	$('#divDueDate').hide();
	$('.cb:checked').closest("tr").find(".duedate").text($('#dueDate').val());
	$("#bulk-actions-popup").fadeOut(100);
}
function OnChangePriority() {
	$('#actionName').val('priority');
	$('#divPriority').hide();
	$('.cb:checked').closest("tr").find(".priorityTd").text($('#ddlPriority option:selected').text());
	$("#bulk-actions-popup").fadeOut(100);
}
function OnChangeCategory() {
	$('#actionName').val('category');
	$('#divPriority').hide();
	$('.cb:checked').closest("tr").find(".categoryName").text($('#selCategory option:selected').text());
	$("#bulk-actions-popup").fadeOut(100);
}
function OnChangeCustomStatus() {
	$('#actionName').val('customstatus');
	$('#divCustomStatus').hide();
	$('.cb:checked').closest("tr").find(".statusName span").text($('#divCustomStatus option:selected').text());
	$("#bulk-actions-popup").fadeOut(100);
}
function OnChangeTech() {
	$('#actionName').val('assign');
	$('#divAssignTo').hide();
	var selected = $('#selTechId option:selected');
	var text = selected.text();
	if (selected.val() == 0)
		text = ''; // unassigned
		
	$('.cb:checked').closest("tr").find(".techTd").text(text);
	$("#bulk-actions-popup").fadeOut(100);
}
function OnClose() {
	if (!confirm("Are you sure you want to close the selected tickets?")) return;
	$('#actionName').val('close');
	$("#bulk-actions-popup").fadeOut(100);
	if (IndexPageModel && IndexPageModel.ListMode != 'ShowAll') //are we at ticket grid looking at other than "show all"? then remove from the grid
		RemoveCheckedFromGrid();
}
function OnReply() {
	$('#actionName').val('reply');
	$("#bulk-actions-popup").fadeOut(100);
}
function UncheckAll() {
	$('.cb:checked').click();
	$("#bulk-actions-popup").fadeOut(100);
}

//ssigns onclick handlers that hightlight rows
function InitCheckboxCellClick() {
	gridPopup.AttachToTable($("#tblTickets"), function () {
		//onshow callback - lets see if user is actually allowed to close tickets, if not - hide the "close" link
		if (!GridApp.restrictClosing) return; //closing allowed to anyone
		if (GridApp.isAdmin) return; //or he's admin anyway
		if (!Array.prototype.includes) return; //older browser

		//finally check allowed categories
		$("#bulkCloseLink").show(); //reset visibility
		$(".cb:checked").not(".cbAll").closest("tr").each(function (index, element) { //iterate through selected tickets
			var catId = $(this).data("categoryid");
			if (!GridApp.allowedCategories.includes(catId)) {
				$("#bulkCloseLink").hide();
				return false; //break early from .each()
			}
		});
	});
}
	
function RemoveBadge(event, ticketID) {
	event.preventDefault();
	event.stopPropagation();
	$.get(GridApp.Url + "/Ticket/RemoveBadge", { ticketId: ticketID }, function (data) {
		$(".fortech-badge, .cust-badge", "#ticketRow" + ticketID).fadeOut('fast');
	});
}