﻿(function () {
	var filesToUpload = [];
	var filesCurrentlyUploading = 0;

	var inputElement = document.getElementById("filesInput");
	inputElement.addEventListener("change", handleFiles, false);
	function handleFiles() {
		// convert FileList to array and pass it to the loop
		var filesToAdd = [];
		for (i = 0; i < this.files.length; i++) {
			filesToAdd.push(this.files[i]);
		}
		AddFilesLoop(filesToAdd, false);
	}

	var dropzoneContainer;
	//init dragndrop
	$(function () {
		dropzoneContainer = $(".dropzoneContainer"); //turn the entire parent element into a drop zone because the div itself is too small
		if (dropzoneContainer.length == 0)
			dropzoneContainer = $(".fileupload").parent();

		dropzoneContainer.on("dragover", function (event) {
			event.preventDefault();
		});

		dropzoneContainer.append($(".dropzone"));

		// show dropzone when drag starts, hide when stops
		// details https://stackoverflow.com/a/14248483/254160
		var body = $('body'),
			showDrag = false,
			timeout = -1;

		var dropzoneShow = function () {
			if (dropzoneContainer.css("display") != "none") {
				dropzoneContainer.css("position", "relative");
				//align the label in the container
				var margin = $(".dropzone").height() / 2 - $("div", ".dropzone").height() / 2;
				$("div", ".dropzone").css("margin-top", margin);
				$(".dropzone").fadeIn();
				showDrag = true;
			}
		};

		body.bind('dragenter', dropzoneShow);
		setTimeout(function () { if (window.wswgEditor) $(wswgEditor.getEditorDoc()).bind('dragenter', dropzoneShow) }, 1000); //bind dropzone to wswgeditor too

		body.bind('dragover', function () {
			showDrag = true;
		});
		body.bind('dragleave', function (e) {
			showDrag = false;
			clearTimeout(timeout);
			timeout = setTimeout(function () {
				if (!showDrag) { hideDropzone(); }
			}, 100);
		});

		body.bind("dragend", function () {
			hideDropzone();
		});

		//capture
		if (!navigator.mediaDevices || !navigator.mediaDevices.getDisplayMedia)
			$('#aCapture').remove(); //hide in old browsers
		else {
			$("#aCapture").click(function () {
				var html = "<div class='outerroundedbox'><button type='button' id='btnVideo'><i class='fa fa-video-camera'></i> Record a video</button><button type='button' id='btnScreenshot' class='graybutton'><i class='fa fa-photo'></i> Take a screenshot</button></div>";
				$.modal(html);
				$('#btnVideo').click(function() { captureScreen(false); });
				$('#btnScreenshot').click(function() { captureScreen(true); });
			});
		}
	});
	document.getElementsByClassName("dropzone")[0].addEventListener("drop", fileDrop);

	function hideDropzone() {
		$(".dropzone").fadeOut("fast", function () {
			dropzoneContainer.css("position", "static");
		});
	}

	function fileDrop(ev) {
		ev.preventDefault();
		hideDropzone();
		// If dropped items aren't files, reject them
		var dt = ev.dataTransfer;
		var filesToAdd = [];
		if (dt.items) {
			// Use DataTransferItemList interface to access the file(s)
			for (var i = 0; i < dt.items.length; i++) {
				if (dt.items[i].kind == "file") {
					var f = dt.items[i].getAsFile();
					filesToAdd.push(f);
				}
			}
			AddFilesLoop(filesToAdd, true);
		} else {
			// Use DataTransfer interface to access the file(s)
			for (i = 0; i < dt.files.length; i++) {
				filesToAdd.push(dt.files[i]);
			}
			AddFilesLoop(filesToAdd, true);
		}
	}

	// use a 100ms delay between uploading files
	// this is a possible fix for HTTP2 issues and Chrome
	// ticket #23825168
	var fileLoopCounter = 0;
	function AddFilesLoop(files, checkInline) {
		setTimeout(function () {
			if (fileLoopCounter < files.length) {
				AddFile(files[fileLoopCounter], checkInline);
				fileLoopCounter++;
				AddFilesLoop(files, checkInline);
			} else {
				fileLoopCounter = 0;
			}
		}, 100);
	}

	function captureScreen(isScreenshot) {
		$.modal.close();
		var html = "<div><video id='vidCapture' style='width:600px;height:400px;background:#222' playsinline autoplay loop muted controls></video><br>\
			<button id='btnSaveCapture' style='display:none'>Save</button><button id='btnStopCapture' style='display:none'>Stop recording</button><button id='btnCancelCapture' style='display:none' class='graybutton'>Discard</button></div>";
		$.modal(html, {overlayClose:false});

		var vidElement = $("#vidCapture")[0];
		vidElement.muted = true;
		var voiceStream = null;
		if (!isScreenshot && confirm("Record microphone too?")) {
			try {
				eval('(async () => { voiceStream = await navigator.mediaDevices.getUserMedia({ audio: true }); })()');
			}
			catch(e) { } //user did not permit the mic
		}

		navigator.mediaDevices.getDisplayMedia({ video: true }).then(function (stream) {
			if (voiceStream)
				voiceStream.getAudioTracks().forEach(function (t) { stream.addTrack(t); });

			var chunks = [];
			var recording = null;
			var started = true;

			vidElement.srcObject = stream; //connect stream to the video element

			if (!isScreenshot)
				$("#btnStopCapture").show();

			var mediaRecorder = new MediaRecorder(stream, { mimeType: 'video/webm' });
			mediaRecorder.addEventListener('dataavailable', function(event) {
				if (event.data && event.data.size > 0) {
					chunks.push(event.data);

					if (isScreenshot)
						setTimeout(stopCapture, 200);
				}
			});

			function stopCapture() {
				if (!started) return; //to prevent calling twice
				started = false;
				mediaRecorder.stop();
				stream.getTracks().forEach(function (track) { track.stop(); });
				if (voiceStream) {
					vidElement.muted = false;
					voiceStream.getTracks().forEach(function (track) { track.stop(); });
					voiceStream = null;
				}
			}

			mediaRecorder.onstop = function (e) {
				$("#btnStopCapture").hide();

				var blob = new Blob(chunks, { type: 'video/webm' });
				recording = window.URL.createObjectURL(blob);

				vidObjectCleanup();
				vidElement.src = recording;
				vidElement.load();

				if (isScreenshot) {
					vidElement.addEventListener("loadeddata", function () {
						const canvas = document.createElement("canvas");
						canvas.width = vidElement.videoWidth;
						canvas.height = vidElement.videoHeight;
						canvas.getContext('2d').drawImage(vidElement, 0, 0, canvas.width, canvas.height);
						canvas.toBlob(function (imgBlob) {
							imgBlob.name = "screenshot.png";
							AddFile(imgBlob);
							$.modal.close();
							vidObjectCleanup();
						});
					});
					return;
				}

				$('#btnCancelCapture').show().click(function () {
					vidObjectCleanup();
					$.modal.close();
				});
				$('#btnSaveCapture').show().text("Save (" + niceBytes(blob.size) + ")").click(function () {
					blob.lastModifiedDate = new Date(); //https://stackoverflow.com/a/29390393/56621
					blob.name = 'video.webm';
					AddFile(blob);
					$.modal.close();
					vidObjectCleanup();
				});;
			}

			function vidObjectCleanup() {
				vidElement.pause();
				vidElement.srcObject = null;
				vidElement.removeAttribute('src'); // empty source
				vidElement.load();
			}

			stream.addEventListener('inactive', stopCapture);
			$("#btnStopCapture").click(stopCapture);

			mediaRecorder.start(10);
		}).catch(function (e) {
			console.log(e);
			$.modal.close(); return;
		});
	}

	const units = ['bytes', 'KB', 'MB', 'GB', 'TB', 'PB', 'EB', 'ZB', 'YB'];

	function niceBytes(x) {
		let l = 0, n = parseInt(x, 10) || 0;
		while (n >= 1024 && ++l) {
			n = n / 1024;
		}
		return (n.toFixed(n < 10 && l > 0 ? 1 : 0) + units[l]);
	}

	function AddFile(file, checkInline) {
		if (/(\.bat|\.cmd|.com|\.exe|\.vbs)$/i.test(file.name)) {
			alert("Restricted file extension");
			return;
		}

		// dropped images are pasted straight to the editor as inline base64 images
		// unless 1. "browse" was clicked, so it's not d'n'd 
		// 2. there is no editor on the page (for example assets edit page)
		if (file.type.match('image.*') && checkInline && typeof wswgEditor !== 'undefined') {
			AddInlineImg(file);
			return;
		}

		filesToUpload.push(file);
		var indicatorSrc = $(".fileupload").data("indicator-url");

		var fileElem = $("<div class='file'>\
				<img class='indicator' style='height:10px' src='" + indicatorSrc + "' />\
				<a class='removeLink fa fa-times' style='display:none' href='javascript:void(0)' title='Remove this file' onclick='FileUploadHelper.removeFile(\"" + file.name + "\", this)'></a>\
				<i style='display:none;' class='field-validation-error fa fa-exclamation-triangle' title='Could not upload this file. Probably the file is too big'></i>\
				<a class='previewFile grey' target='_blank' title='preview' href='#'>" + file.name + "</a>\
			</div>");

		$(".fileList").append(fileElem).hide().fadeIn();

		var formData = new FormData();
		formData.append(file.name, file, file.name);
		filesCurrentlyUploading++;
		$.ajax({
			url: $(".fileupload").data("upload-url") + "?key=" + $(".uploadKey").val(),
			data: formData,
			processData: false,
			contentType: false,
			type: 'POST',
			success: function (data) {
				$(".indicator", fileElem).hide();
				$(".removeLink", fileElem).show();
				$(".previewFile", fileElem).click(function () { window.open(URL.createObjectURL(file), 'Name', 'toolbar=0,location=0,status=0,menubar=0,resizable=0,top=' + (window.screenY+100) + ',left=' + (window.screenX+window.innerWidth-350) + ',width=350,height=250'); });
				filesCurrentlyUploading--;
				inputElement.value = "";
			},
			error: function (error) {
				$(".indicator", fileElem).hide();
				$(".field-validation-error", fileElem).show();
				filesCurrentlyUploading--;
				inputElement.value = "";
			}
		});

	}

	function AddInlineImg(file) {
		//we have a file handle, need to read it with file reader!
		var reader = new FileReader();

		// Closure to capture the file information.
		reader.onload = (function (theFile) {
			//get the data uri
			var dataURI = theFile.target.result;
			wswgEditor.AddImg(dataURI);
		});
		//this reads in the file, and the onload event triggers, which adds the image to the div at the carat
		reader.readAsDataURL(file);
	}

	return FileUploadHelper = {
		HasFilesToUpload: function () {
			return filesToUpload.length > 0;
		},

		removeFile: function (name, elem) {
			$.post($(".fileupload").data("remove-url"), { name: name, key: $(".uploadKey").val()});
			filesToUpload = filesToUpload.filter(function (f) {
				return f.name !== name;
			});
			$(elem).parent().fadeOut();
			$(inputElement).val(""); //cleanup the input-file so "onchange" fires again
		},

		uploadInProgress: function () { return filesCurrentlyUploading > 0; },

		reinit: function () {
			filesToUpload = [];
			filesCurrentlyUploading = 0;
			$(".file").remove();
		},

		unbindDragEvents: function () {
			$("body").unbind('dragenter').unbind('dragover').unbind('dragleave').ubind("dragend");
		},

		//adds a file that's already in the ticket (for "resend comment" functionality)
		//by adding a hidden field with fileID
		addExistingFile: function (fileId, name) {
			var fileElem = $("<div class='file'><a href='javascript:;' title='Remove this file'><i class='fa fa-times' aria-hidden='true'></i></a> " + name + "<input type='hidden' name='oldfile' value='" + fileId + "'></div>");
			fileElem.find("a").click(function () { $(this).parent().fadeOut(function () { $(this).remove(); }); });
			$(".fileList").append(fileElem).hide().fadeIn();
		}
	}

})();
